# Database C6StampeCentralizzate collaudo
[Diagnostics.CodeAnalysis.SuppressMessageAttribute('PSUseDeclaredVarsMoreThanAssignments', '')]
$DBStampeColl = @{
    sqlServerName = "bfdskrepsei01c.sysfideuram.sysbancafideuram.it"
    databaseName = "C6StampeCentralizzate"
    userName = "F701264"
    securePassword = "contrsei"
}

# Database C6StampeCentralizzate produzione
[Diagnostics.CodeAnalysis.SuppressMessageAttribute('PSUseDeclaredVarsMoreThanAssignments', '')]
$DBStampeProd = @{
    sqlServerName = "bfdskreport01p.fideuram.bancafideuram.it"
    databaseName = "C6StampeCentralizzate"
    userName = "F701264"
    securePassword = "contrsei"
}

# Database SEIReport Lettera benvenuto Produzione
[Diagnostics.CodeAnalysis.SuppressMessageAttribute('PSUseDeclaredVarsMoreThanAssignments', '')]
$DBBenvProd = @{
    sqlServerName = "bfdskreport02p.fideuram.bancafideuram.it"
    databaseName = "SEIReport"
    userName = "SEIReport"
    securePassword = "SEIReport"
}

# Database C6StampeCentralizzate locale
[Diagnostics.CodeAnalysis.SuppressMessageAttribute('PSUseDeclaredVarsMoreThanAssignments', '')]
$DBStampeLoc = @{
    sqlServerName = "DATABASE_PDC_LOCALE"
    databaseName = "C6StampeCentralizzate"
    userName = "F701264"
    securePassword = "contrsei"
}

# Database C6StampeCentralizzate testbes
[Diagnostics.CodeAnalysis.SuppressMessageAttribute('PSUseDeclaredVarsMoreThanAssignments', '')]
$DBStampeTestbes = @{
    sqlServerName = "testbes.armundia.com"
    databaseName = "C6StampeCentralizzate"
    userName = "sa"
    securePassword = "_p1sap1a"
}

# Configurazione database
$config = @{
    # Directory di log
    WorkDir = Split-Path -Path $PSScriptRoot -Parent
    LogDir = Join-Path (Split-Path -Path $PSScriptRoot -Parent) "logs"
    SqlDir = Join-Path (Split-Path -Path $PSScriptRoot -Parent) "sql"
}

$DBI = $DBStampeColl
$DBO = $DBStampeLoc
# Esporta le variabili come variabili d'ambiente
$env:dbHostInput = $DBI.sqlServerName
$env:dbNameInput = $DBI.databaseName
$env:dbUserInput = $DBI.userName
$env:dbPasswordInput = $DBI.securePassword

$env:dbHostOutput = $DBO.sqlServerName
$env:dbNameOutput = $DBO.databaseName
$env:dbUserOutput = $DBO.userName
$env:dbPasswordOutput = $DBO.securePassword

$env:logDir = $config.LogDir
$env:workDir = $config.WorkDir
$env:sqlDir = $config.SqlDir

# Funzione per ottenere la connection string
function Get-DatabaseConnectionString {
    return "Server=$($DBO.sqlServerName);Database=$($DBO.databaseName);User Id=$($DBO.userName);Password=$($DBO.securePassword);"
}

# Crea directory di log se non esiste
if (-not (Test-Path $config.LogDir)) {
    New-Item -ItemType Directory -Path $config.LogDir | Out-Null
}

# La configurazione sarà disponibile quando lo script viene dot-sourced
