﻿CREATE TABLE [consulenzaUnica].[dbo].[Cliente] (
    [chiaveCliente] bigint NOT NULL,
    [codFis] varchar(16) NULL,
    [pIva] varchar(11) NULL,
    [codMan] varchar(6) NULL,
    [nome] varchar(50) NULL,
    [cognome] varchar(100) NULL,
    [dtNascita] datetime NULL,
    [indirizzo] varchar(100) NULL,
    [numCivico] varchar(5) NULL,
    [codComRes] int NULL,
    [codProvRes] int NULL,
    [codNazRes] int NULL,
    [cap] varchar(10) NULL,
    [frequenza] int NULL,
    [rendicSemestrale] char(1) NULL,
    [codStatoCivile] int NULL,
    [genere] varchar(1) NULL,
    [codTitoloStudio] int NULL,
    [flagCanOnLine] bit NULL,
    [numFigli] int NULL,
    [codProvNasc] int NULL,
    [codComNasc] int NULL,
    [codNazNasc] int NULL,
    [fonte] varchar(150) NULL,
    [pinCode] varchar(128) NULL,
    [cittadinanza] varchar(256) NULL,
    [dtInserimento] datetime NULL,
    [flagLiberatoria] bit NULL,
    [dtInizioValidita] datetime NULL,
    [dtAggiornamento] datetime NULL,
    [codFisGiuridiche] varchar(16) NULL,
    [flagSoggettoTerzo] bit NULL,
    [capacitaSopportarePerdite] varchar(50) NULL,
    [condizioniAgevolateFonditalia] varchar(20) NULL
);
GO

-- Popolamento tabella
-- INSERT INTO [consulenzaUnica].[dbo].[Cliente]
-- SELECT * FROM [CONSUNI].[consulenzaUnica].[dbo].[Cliente];
-- GO