﻿CREATE TABLE [consulenzaUnica].[dbo].[DettProdottiTerzi] (
    [chiaveProdottoTerzi] bigint NOT NULL,
    [idIntermediario] int NULL,
    [alberatura] int NULL,
    [nomeIntermediario] varchar(128) NULL,
    [dtInizioInvest] datetime NULL,
    [totVersato] decimal(18,2) NULL,
    [totPrelevato] decimal(18,2) NULL,
    [valutaTotPrelevato] varchar(3) NULL,
    [chiaveProdotto] int NULL,
    [numQuote] decimal(19,7) NULL,
    [divQuoteProd] varchar(3) NULL,
    [dtSottoscrizione] datetime NULL,
    [valutaPremioVers] varchar(3) NULL,
    [tipoPolizza] varchar(256) NULL,
    [tipoVersamento] varchar(256) NULL,
    [tipoFormaPensionistica] varchar(256) NULL,
    [capitaleInvestito] decimal(18,2) NOT NULL,
    [valutaCapInvestito] varchar(3) NULL,
    [contoPrincipale] bit NULL,
    [addebitoUtenze] bit NULL,
    [accreditoStipPens] bit NULL,
    [cartaCredito] bit NULL,
    [addebitoMutuo] bit NULL,
    [isin] varchar(256) NULL,
    [lineaFinanziaria] varchar(256) NULL,
    [fabbisognoPrev] bit NULL,
    [dtDecorrenza] datetime NULL,
    [modalitaUso] varchar(256) NULL,
    [ctvUltimaPrestNota] decimal(18,2) NULL,
    [dtUltimaPrestNota] datetime NULL,
    [flgPrestazioneScad] bit NULL,
    [dtTermineVers] datetime NULL,
    [dtUltimoPremioNoto] datetime NULL,
    [nomeCompagnia] varchar(512) NULL,
    [valutaCtvUltPrestNota] varchar(3) NULL,
    [profilo] smallint NULL,
    [PercImposte] decimal(18,2) NULL
);
GO

-- Popolamento tabella
-- INSERT INTO [consulenzaUnica].[dbo].[DettProdottiTerzi]
-- SELECT * FROM [CONSUNI].[consulenzaUnica].[dbo].[DettProdottiTerzi];
-- GO